import openai
import csv

# Set up your OpenAI API credentials
openai.api_key = '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'

# Load the categories from the CSV files
def load_categories(file_path):
    with open(file_path, 'r') as file:
        reader = csv.reader(file)
        categories = [row[0] for row in reader]
    return categories

categories_file1 = 'set1.csv'
categories_file2 = 'set2.csv'
output_file = 'matching_results.csv'  # Output file for saving the results

categories1 = load_categories(categories_file1)
categories2 = load_categories(categories_file2)

# Perform text matching using OpenAI's API
def get_best_match(category, candidates):
    prompt = f"What is the best match for category '{category}' from the second pool?\nOptions: {', '.join(candidates)}"

    # Split prompt into smaller parts
    max_prompt_tokens = 4096  # Maximum token limit for prompt
    prompt_parts = [prompt[i:i+max_prompt_tokens] for i in range(0, len(prompt), max_prompt_tokens)]

    # Send multiple requests and combine the results
    responses = []
    for part in prompt_parts:
        response = openai.Completion.create(
            engine='text-davinci-003',
            prompt=part,
            max_tokens=50,  # Adjust as needed
            n=1,
            stop=None,
            temperature=0.5  # Adjust as needed
        )
        response_text = response.choices[0].text.strip().replace("\n", "")
        responses.append(response_text)

    best_match = ' '.join(responses)
    return best_match

# Match categories from file1 to file2 and save results
with open(output_file, 'w', newline='') as csvfile:
    writer = csv.writer(csvfile)
    writer.writerow(['Category 1', 'Category 2'])  # Header row

    for i, category1 in enumerate(categories1):
        try:
            match = get_best_match(category1, categories2)
            writer.writerow([category1, match])
            csvfile.flush()  # Flush the buffer to write the result immediately
            print(f"[{i+1}/{len(categories1)}] Match found for '{category1}'")
        except Exception as e:
            print(f"[{i+1}/{len(categories1)}] Error occurred for '{category1}': {e}")

    print(f"Matching results saved to '{output_file}'.")
